<?php 
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

function parse_fract( $f )
{
  $nd = explode( '/', $f );
  return $nd[0]/$nd[1];
}

function parse_lat_lon( $arr )
{
  $v=0;
  $v += parse_fract( $arr[0] );
  $v += parse_fract( $arr[1] )/60;
  $v += parse_fract( $arr[2] )/3600;
  return $v;
}

if ( isset($_POST['submit']) )
  $sync_options = array(
//    'no_overwrite' => isset($_POST['no_overwrite']),
    'simulate' => isset($_POST['simulate']),
    'cat_id' => isset($_POST['cat_id']) ? (int)$_POST['cat_id'] : 0,
    'subcats_included' => isset($_POST['subcats_included']),
    );
else
  $sync_options = array(
//    'no_overwrite' => true,
    'simulate' => true,
    'cat_id' => 0,
    'subcats_included' => true,
    );


$query='
SELECT id
  FROM '.SITES_TABLE.'
  WHERE galleries_url NOT LIKE "http://%"
;';
$site_ids = array_from_query($query, 'id');

if ( isset($_POST['submit']) )
{
  $query='
SELECT id FROM '.CATEGORIES_TABLE.'
  WHERE dir IS NOT NULL AND site_id IN ('.implode(',', $site_ids).')
';
  $where_clauses = array();
  if ( $sync_options['cat_id']!=0 )
  {
    if ( $sync_options['subcats_included'])
      $query .= 'AND uppercats REGEXP \'(^|,)'.$sync_options['cat_id'].'(,|$)\'';
    else
      $query .= 'AND id='.$sync_options['cat_id'];
  }
  $cat_ids = array_from_query($query, 'id');
  
  $query='
SELECT id,path,lat,lon
  FROM '.IMAGES_TABLE.' INNER JOIN '.IMAGE_CATEGORY_TABLE.' ON id=image_id
  WHERE category_id IN ('.implode(',', $cat_ids).')
  GROUP BY id';
  
  $images = hash_from_query( $query, 'id');
  $datas = array();
  $errors = array();
  foreach ($images as $image)
  {
    $exif = @read_exif_data( $image['path'] );
    if ( empty($exif) )
      continue;
    $exif = array_intersect_key( $exif, array_flip( array('GPSLatitudeRef', 'GPSLatitude', 'GPSLongitudeRef', 'GPSLongitude') ) );
    if ( count($exif)!=4 )
      continue;
    if ( !in_array($exif['GPSLatitudeRef'], array('S', 'N') ) )
    {
      $errors[] = $image['path']. ': GPSLatitudeRef not S or N';
      continue;
    }
    if ( !in_array($exif['GPSLongitudeRef'], array('W', 'E') ) )
    {
      $errors[] = $image['path']. ': GPSLongitudeRef not W or E';
      continue;
    }
    if (!is_array($exif['GPSLatitude']) or !is_array($exif['GPSLongitude']) )
    {
      $errors[] = $image['path']. ': GPSLatitude and GPSLongitude are not arrays';
      continue;
    }
    $lat = parse_lat_lon( $exif['GPSLatitude'] );
    if ( $exif['GPSLatitudeRef']=='S' )
      $lat = -$lat;
    $lon = parse_lat_lon( $exif['GPSLongitude'] );
    if ( $exif['GPSLongitudeRef']=='W' )
      $lon = -$lon;
    $datas[] = array (
      'id' => $image['id'],
      'lat' => $lat,
      'lon' => $lon,
      );
  }
  foreach ($errors as $error)
    $template->assign_block_vars( 'sync_errors.error', array('TEXT'=>$error) );

  if ( count($datas)>0 and !$sync_options['simulate'] )
  {
    mass_updates(
        IMAGES_TABLE,
        array(
          'primary' => array('id'),
          'update'  => array('lat', 'lon')
        ),
        $datas
      );
    rvm_invalidate_cache();
  }
  
  $template->assign_block_vars(
    'metadata_result',
    array(
      'NB_ELEMENTS_DONE' => count($datas),
      'NB_ELEMENTS_CANDIDATES' => count($images),
      'NB_ERRORS' => count($errors),
      ));

}


$query = '
SELECT id, name, uppercats, global_rank
  FROM '.CATEGORIES_TABLE.'
  WHERE dir IS NOT NULL
    AND site_id IN ('.implode(',',$site_ids).')';

display_select_cat_wrapper($query,
                           array( $sync_options['cat_id'] ),
                           'category',
                           false);
$template->assign_vars(
    array(
      'SUBCATS_INCLUDED_CHECKED' => $sync_options['subcats_included'] ? 'checked="checked"' : ''
    )
  );

?>
